#ifndef GOST28147_89
#define GOST28147_89

#include <linux/types.h>

#define GOST_BLOCK_SIZE 8
#define GOST_MIN_KEY_SIZE 32
#define GOST_MAX_KEY_SIZE 32

struct  gost_s_box {
	char  *name;
	char  *oid;
	u8 sbox[8][16];
	u8 sbox_opti[4][256];
};


struct gost_ctx {
	u8 key_enc[GOST_MAX_KEY_SIZE];
	u8 key_dec[GOST_MAX_KEY_SIZE];
	u8 key_length;
	struct gost_s_box *sbox;
};

static struct gost_s_box gost_sboxes[] = {
	/*Russian Central Bank*/
	{ "test_3411",
	  "1.2.643.2.2.30.0",
	  {
		  {0x4, 0xA, 0x9, 0x2, 0xD, 0x8, 0x0, 0xE, 0x6, 0xB, 0x1, 0xC, 0x7, 0xF, 0x5, 0x3},
		  {0xE, 0xB, 0x4, 0xC, 0x6, 0xD, 0xF, 0xA, 0x2, 0x3, 0x8, 0x1, 0x0, 0x7, 0x5, 0x9},
		  {0x5, 0x8, 0x1, 0xD, 0xA, 0x3, 0x4, 0x2, 0xE, 0xF, 0xC, 0x7, 0x6, 0x0, 0x9, 0xB},
		  {0x7, 0xD, 0xA, 0x1, 0x0, 0x8, 0x9, 0xF, 0xE, 0x4, 0x6, 0xC, 0xB, 0x2, 0x5, 0x3},
		  {0x6, 0xC, 0x7, 0x1, 0x5, 0xF, 0xD, 0x8, 0x4, 0xA, 0x9, 0xE, 0x0, 0x3, 0xB, 0x2},
		  {0x4, 0xB, 0xA, 0x0, 0x7, 0x2, 0x1, 0xD, 0x3, 0x6, 0x8, 0x5, 0x9, 0xC, 0xF, 0xE},
		  {0xD, 0xB, 0x4, 0x1, 0x3, 0xF, 0x5, 0x9, 0x0, 0xA, 0xE, 0x7, 0x6, 0x8, 0x2, 0xC},
		  {0x1, 0xF, 0xD, 0x0, 0x5, 0x7, 0xA, 0x4, 0x9, 0x2, 0x3, 0xE, 0x6, 0xB, 0x8, 0xC}
	  },
	  {
		  {0},{0},{0},{0}
	  }

	}
};

#endif /* GOST28147_89 */
